#include <stdio.h>
#include <io.h>

#define PC_SPEAKER

void inittimer()
{
_asm mov al,36h
_asm out 43h,al
_asm xor al,al
_asm out 40h,al
_asm out 40h,al
}


unsigned int getcount()
{
_asm mov al,06h
_asm out 43h,al
_asm in al,40h
_asm mov cl,al
_asm in al,40h
_asm mov ah,al
_asm mov al,cl
}

void set0()
{
//#ifdef PC_SPEAKER
  _asm in al,61h
  _asm and al,0fdh
  _asm out 61h,al
//#endif
_asm mov dx,378h
_asm mov al,0
_asm out dx,al
}

void set1()
{
#ifdef PC_SPEAKER
  _asm in al,61h
  _asm or al,2
  _asm out 61h,al
#endif
_asm mov dx,378h
_asm mov al,1
_asm out dx,al
}

void delay()
{
//for (int i=0;i<=10240;i++);
unsigned int d0=getcount();
while ((d0-getcount())<1085);
}

void playbyte(unsigned char byte)
{
for (int i=0;i<8;i++)
  {
  if (byte & 0x80)
    {
    set1();
    delay();
    set0();
    delay();
    }
  else
    {
    set0();
    delay();
    set1();
    delay();
    }
  byte<<=1;
  }
}

void playfile(char *filename)
{
unsigned int l;
unsigned char *p;
FILE *f;
f=fopen(filename,"rb");
if (!f) return;
l=filelength(fileno(f));
p=new unsigned char [l];
if (!p)
  {
  fclose(f);
  return;
  }
fread(p,l,1,f);
fclose(f);
inittimer();

int i;

_asm cli
for (i=0;i<=255;i++)
  playbyte(0);
playbyte(0xe6);
for (i=0;i<l;i++)
  playbyte(p[i]);
_asm sti
delete[] p;
}

int main(int argn,char** argc)
{
if (argn!=2)
  {
  printf("Usage: playrk filename\n");
  return 1;
  }
playfile(argc[1]);
return 0;
}
