#define SPEED 1190

#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <dos.h>

void inittimer()
{
_asm mov al,36h
_asm out 43h,al
_asm xor al,al
_asm out 40h,al
_asm out 40h,al
}

unsigned int getcount()
{
_asm mov al,06h
_asm out 43h,al
_asm in al,40h
_asm mov cl,al
_asm in al,40h
_asm mov ah,al
_asm mov al,cl
}

void delay()
{
unsigned int d0=getcount();
while ((d0-getcount())<SPEED/*1638*/);
}

static unsigned startcount;

void starttime()
{
startcount=getcount();
}

int passed()
{
return ((startcount-getcount())>10000);
}

int getval()
{
_asm mov dx,379h
_asm in al,dx
_asm rol al,1
_asm and al,1
_asm mov ah,0
}

int readbit(int &bit)
{
delay();
int temp;

starttime();
temp=getval();
while (temp==getval())
  if (passed())
    return 0;
bit=temp;
return 1;
}

static unsigned char mask;

int syncbyte()
{
unsigned char byte=0;
int bit;
for(;;)
  {
  if (!readbit(bit))
    return 0;
  byte=(byte<<1) | bit;
  if (byte==0xe6)
    {
    mask=0;
    return 1;
    }
  if (byte==0x19)
    {
    mask=0xff;
    return 1;
    }
  }
}

int readbyte(unsigned char &byte)
{
int bit,i;
for(i=0;i<8;i++)
  {
  if (!readbit(bit))
    return 0;
  byte=(byte<<1) | bit;
  }
byte^=mask;
return 1;
}

void readfile(char *filename)
{
unsigned int l;
unsigned char *p;
FILE *f;
f=fopen(filename,"wb");
if (!f) return;
p=new unsigned char [40000];
if (!p)
  {
  fclose(f);
  return;
  }
unsigned int i=0;

inittimer();  // 祬- 窠 Borland C++  ९ணࠬ
              //  DOS   㦭
_asm cli
if (!syncbyte())
  {
  _asm sti
  delete[] p;
  fclose(f);
  return;
  }
*(char far *)MK_FP(0xb800,1)=0xcc;
while (readbyte(p[i]))
  i++;
_asm sti
fwrite(p,i,1,f);
delete[] p;
fclose(f);
}

int main(/*int argn,char** argc*/)
{
int i=0;
for(;;)
  {
  readfile("output.rk");
  //return 0;
  //_asm cli
  //syncbyte();
  //_asm sti
  printf("%d. Done\n",i++);
  if (getch()==27) return 0;
  }
}
